<?php

namespace ByDedi\AdminBundle\Annotation;

use Doctrine\Common\Annotations\AnnotationReader;

class UploadableAnnotationReader
{

    /**
     * @var AnnotationReader
     */
    private $reader;

    /**
     * UploadableAnnotationReader constructor.
     * @param AnnotationReader $reader
     */
    public function __construct(AnnotationReader $reader)
    {
        $this->reader = $reader;
    }

    /**
     * @param $entity
     * @return array
     */
    public function getUploadableFields($entity)
    {
        $properties = $this->getEntityUploadableFields($entity);
        return $properties;
    }

    private function getEntityUploadableFields($entity)
    {
        $reflection = new \ReflectionClass(get_class($entity));
        $properties = [];
        foreach ($reflection->getProperties() as $property) {
            $annotation = $this->reader->getPropertyAnnotation($property, Uploadable::class);
            if ($annotation !== null) {
                $properties[$property->getName()] = $annotation;
            }
        }
        return $properties;
    }
}
